Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.valves
Class AccessLogValve

    java.lang.Object
      |
      +--org.apache.catalina.valves.ValveBase
            |
            +--org.apache.catalina.valves.AccessLogValve

public final class AccessLogValve
extends ValveBase
implements Lifecycle

Implementation of the Valve interface that generates a web server access log with the detailed line contents matching a configurable pattern. The syntax of the available patterns is similar to that supported by the Apache `mod_log_config` module. As an additional feature, automatic rollover of log files when the date changes is also supported.

Patterns for the logged message may include constant text or any of the following replacement strings, for which the corresponding information from the specified Response is substituted:

- %a - Remote IP address
- %A - Local IP address
- %b - Bytes sent, excluding HTTP headers, or '-' if no bytes were sent
- %B - Bytes sent, excluding HTTP headers
- %h - Remote host name
- %H - Request protocol
- %l - Remote logical username from identd (always returns '-')
- %m - Request method
- %p - Local port
- %q - Query string (prepended with a '?' if it exists, otherwise an empty string
- %r - First line of the request
- %s - HTTP status code of the response
- %t - Date and time, in Common Log Format format
- %u - Remote user that was authenticated
- %U - Requested URL path
- %v - Local server name

In addition, the caller can specify one of the following aliases for commonly utilized patterns:

- common - `%h %l %u %t "%r" %s %b`
- combined - `%h %l %u %t "%r" %s %b "%{Referer}i" "%{User-Agent}i"`

FIXME - Improve the parsing so that things like `%{xxx}i` can be implemented.

Version:
  $Revision: 1.10.2.2 $ $Date: 2001/10/25 20:07:26 $
Author:
  Craig R. McClanahan, Jason Brittain

Field Summary
`protected static java.lang.String` | `info` The descriptive information about this implementation.
`protected LifecycleSupport` | `lifecycle` The lifecycle event support for this component.
`protected static java.lang.String[]` | `months` The set of month abbreviations for log messages.

Fields inherited from class org.apache.catalina.valves.ValveBase
`container, info, sm`

Fields inherited from interface org.apache.catalina.Lifecycle
`START_EVENT, STOP_EVENT`

Constructor Summary
`AccessLogValve()` Construct a new instance of this class with default property values.

Method Summary
`void` | `addLifecycleListener(LifecycleListener listener)` Add a lifecycle event listener to this component.
`java.lang.String` | `getDirectory()` Return the directory in which we create log files.
`java.lang.String` | `getInfo()` Return descriptive information about this implementation.
`java.lang.String` | `getPattern()` Return the format pattern.
`java.lang.String` | `getPrefix()` Return the log file prefix.
`java.lang.String` | `getSuffix()` Return the log file suffix.
`void` | `invoke(Request request, Response response, ValveContext context)` Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.
`boolean` | `isResolveHosts()` Get the value of the resolve hosts flag.
`void` | `log(java.lang.String message, java.util.Date date)` Log the specified message to the log file, switching files if the date has changed since the previous log call.
`void` | `removeLifecycleListener(LifecycleListener listener)` Remove a lifecycle event listener from this component.
`void` | `setDirectory(java.lang.String directory)` Set the directory in which we create log files.
`void` | `setPattern(java.lang.String pattern)` Set the format pattern, first translating any recognized alias.
`void` | `setPrefix(java.lang.String prefix)` Set the log file prefix.
`void` | `setResolveHosts(boolean resolveHosts)` Set the resolve hosts flag.
`void` | `setSuffix(java.lang.String suffix)` Set the log file suffix.
`void` | `start()` Prepare for the beginning of active use of the public methods of this component.
`void` | `stop()` Gracefully terminate the active use of the public methods of this component.

Methods inherited from class org.apache.catalina.valves.ValveBase
`getContainer, setContainer`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### info

    protected static final java.lang.String info

  The descriptive information about this implementation.

### lifecycle

    protected LifecycleSupport lifecycle

  The lifecycle event support for this component.

### months

    protected static final java.lang.String[] months

  The set of month abbreviations for log messages.

Constructor Detail

### AccessLogValve

    public AccessLogValve()

  Construct a new instance of this class with default property values.

Method Detail

### getDirectory

    public java.lang.String getDirectory()

  Return the directory in which we create log files.

### setDirectory

    public void setDirectory(java.lang.String directory)

  Set the directory in which we create log files.
  Parameters:
    `directory` - The new log file directory

### getInfo

    public java.lang.String getInfo()

  Return descriptive information about this implementation.
  Overrides:
    getInfo in class ValveBase

### getPattern

    public java.lang.String getPattern()

  Return the format pattern.

### setPattern

    public void setPattern(java.lang.String pattern)

  Set the format pattern, first translating any recognized alias.
  Parameters:
    `pattern` - The new pattern

### getPrefix

    public java.lang.String getPrefix()

  Return the log file prefix.

### setPrefix

    public void setPrefix(java.lang.String prefix)

  Set the log file prefix.
  Parameters:
    `prefix` - The new log file prefix

### getSuffix

    public java.lang.String getSuffix()

  Return the log file suffix.

### setSuffix

    public void setSuffix(java.lang.String suffix)

  Set the log file suffix.
  Parameters:
    `suffix` - The new log file suffix

### setResolveHosts

    public void setResolveHosts(boolean resolveHosts)

  Set the resolve hosts flag.
  Parameters:
    `resolveHosts` - The new resolve hosts value

### isResolveHosts

    public boolean isResolveHosts()

  Get the value of the resolve hosts flag.

### invoke

    public void invoke(Request request,
                       Response response,
                       ValveContext context)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Log a message summarizing the specified request and response, according to the format specified by the `pattern` property.
  Overrides:
    invoke in class ValveBase
  Parameters:
    `request` - Request being processed
    `response` - Response being processed
    `context` - The valve context used to invoke the next valve in the current processing pipeline
  Throws:
    java.io.IOException - if an input/output error has occurred
    javax.servlet.ServletException - if a servlet error has occurred

### log

    public void log(java.lang.String message,
                    java.util.Date date)

  Log the specified message to the log file, switching files if the date has changed since the previous log call.
  Parameters:
    `message` - Message to be logged
    `date` - the current Date object (so this method doesn't need to create a new one)

### addLifecycleListener

    public void addLifecycleListener(LifecycleListener listener)

  Add a lifecycle event listener to this component.
  Specified by:
    addLifecycleListener in interface Lifecycle
  Parameters:
    `listener` - The listener to add

### removeLifecycleListener

    public void removeLifecycleListener(LifecycleListener listener)

  Remove a lifecycle event listener from this component.
  Specified by:
    removeLifecycleListener in interface Lifecycle
  Parameters:
    `listener` - The listener to add

### start

    public void start()
               throws LifecycleException

  Prepare for the beginning of active use of the public methods of this component. This method should be called after `configure()`, and before any of the public methods of the component are utilized.
  Specified by:
    start in interface Lifecycle
  Throws:
    java.lang.IllegalStateException - if this component has already been started
    LifecycleException - if this component detects a fatal error that prevents this component from being used

### stop

    public void stop()
              throws LifecycleException

  Gracefully terminate the active use of the public methods of this component. This method should be the last one called on a given instance of this component.
  Specified by:
    stop in interface Lifecycle
  Throws:
    java.lang.IllegalStateException - if this component has not been started
    LifecycleException - if this component detects a fatal error that needs to be reported

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2001 Apache Software Foundation. All Rights Reserved.